package Enigma;

public class Steckbrett {

	private int[] vertauschung;
	
	/**
	 * Steckbrett anlegen
	 * @param v leerzeichengetrennte Buchstabenpaare, die vertauscht werden sollen, Großbuchstaben! Keine doppelten Buchstaben verwenden!
	 */
	public Steckbrett(String v) {
		// Vertauschungs-Liste anlegen
		this.vertauschung = new int[26];
		for (int i = 0; i < 26; i++) {
			// Standardmäßig: keine Vertauschung
			this.vertauschung[i] = i;
		}
		
		String[] tmp = v.split(" ");
		
		for (int i = 0; i < tmp.length; i++) {
			if (tmp[i].length() != 2) continue;
			
			// lege bei beiden Buchstaben den vertauschten Index ab
			int i1 = tmp[i].charAt(0) - 'A';
			int i2 = tmp[i].charAt(1) - 'A';
			
			this.vertauschung[i1] = i2;
			this.vertauschung[i2] = i1;
		}
	}

	/**
	 * Durchläuft das Steckbrett
	 * @param c Eingabebuchstabe
	 * @return Ausgabebuchstabe
	 */
	public char in(char c) {
		int index = c - 'A';
		
		return (char)(this.vertauschung[index] + 'A');
	}
}
