package Enigma;

public class Walze {

	private String code;
	private int[] verschiebungen;
	
	private int ring;
	private int stellung;
	
	/**
	 * legt eine Walze an
	 * @param code auf welche Buchstaben das Alphabet abgebildet wird
	 * @param ring bei welcher Stellung die nächste Walze ausgelöst werden soll
	 * @param stellung Ausgangsstellung
	 */
	public Walze(String code, int ring, int stellung) {
		this.code = code;
		this.verschiebungen = new int[code.length()];
		for (int i = 0; i < code.length(); i++) {
			this.verschiebungen[i] = code.charAt(i) - 'A' - i;
			
			// System.out.print(this.verschiebungen[i] + " , ");
		}
		// System.out.println();
		
		this.ring = ring % 26;
		this.stellung = stellung % 26;
	}
	
	/**
	 * dreht die Walze eine Stellung weiter
	 * @return true, wenn nächste Walze gedreht werden soll
	 */
	public boolean next() {
		stellung = (stellung + 1) % 26;
		return stellung == ring;
	}
	
	/**
	 * Vertauscht die Buchstaben in Eingangsrichtung
	 * @param c Eingangsbuchstabe
	 * @return Ausgangsbuchstabe
	 */
	public char in(char c) {
		int index = c - 'A';
		int verschiebung = this.verschiebungen[(index + stellung) % 26];

		return (char)((index + 26 + verschiebung) % 26 + 'A');
	}
	
	/**
	 * Vertauscht die Buchstaben in Rückrichtung
	 * @param c Eingangsbuchstabe
	 * @return Ausgangsbuchstabe
	 */
	public char out(char c) {
		int index = this.code.indexOf((c - 'A' + stellung) % 26 + 'A');
		int verschiebung = -this.verschiebungen[(index) % 26];
		
		return (char)((c - 'A' + 26 + verschiebung) % 26 + 'A');
	}
}
